10 KEY OFF: CLS
20 COLOR 3, 0: LOCATE 2, 16: PRINT "DESIGN DATA FOR INTERDIGITAL BANDPASS FILTERS": COLOR 7, 0: PRINT
21 PRINT "   Rook & Taylor (1970); Hinshaw N6JH & Monemzadeh (Ham Radio, Jan 1985)"
22 PRINT "                 I/O revision by Ian White G3SEK 1989-91"
23 '   Uses  equal diameter rods
24 '   G values based on ripple BW. Q/coup on BW @3dB
30 DEF FNRJ (TA, B, C, D) = (B * C - TA * D) / (C * C + D * D)
40 DIM A(200), B(200), C(200), G(200), RK(200), AK(200), FR(100), ALOSS(100)
50 PI = 4 * ATN(1): NFR = 20: N = 3: RIP = 0!: FZGC = 1!: BWMC = 50!: FIRST = -1: ENTER$ = CHR$(17) + CHR$(217)
52 LOCATE 8, 1
54 PRINT "        Press M for millimetres,  or I for inches  > ";
56 T$ = INPUT$(1)
58 IF T$ = "M" OR T$ = "m" THEN UNIT$ = "mm": CV = 25.4:  ELSE IF T$ = "I" OR T$ = "i" THEN UNIT$ = "in": CV = 1 ELSE GOTO 54
60 PRINT UNIT$
70 LOCATE 10, 1: PRINT SPACE$(75): LOCATE 10, 1
72 IF FIRST THEN PRINT "              Groundplane spacing, top-bottom ("; UNIT$; : INPUT ")  : ", H ELSE GOTO 76
74 IF H <= 0 THEN BEEP: GOTO 70 ELSE H = H / CV
76 IF NOT FIRST THEN PRINT USING "              Groundplane spacing, top-bottom (&)  = ##.##"; UNIT$; H * CV
80 LOCATE 11, 1: PRINT SPACE$(75): LOCATE 11, 1
82 IF FIRST THEN PRINT "                                 Rod diameter ("; UNIT$; : INPUT ")  : ", D ELSE GOTO 88
84 IF D <= 0 THEN BEEP: GOTO 80
86 IF D > (.9 * H * CV) THEN BEEP: GOTO 80 ELSE D = D / CV
88 IF NOT FIRST THEN PRINT USING "                                 Rod diameter (&)  = ##.##"; UNIT$; D * CV
90 LOCATE 25, 10: COLOR 3, 0: PRINT "Press " + ENTER$ + " for default values shown in [square brackets]"; : COLOR 7, 0
100 LOCATE 12, 1
110 PRINT USING "Overhang from centre of first _& last rod [##.##&]  :"; .7 * H * CV; UNIT$;
120 INPUT " ", E: IF E = 0 THEN E = .7 * H ELSE E = E / CV
130 PRINT USING "               Number of elements (7 or less) [##]  :"; N;
135 INPUT " ", T: IF T <> 0 AND T < 8 THEN N = T
140 PRINT USING "     Passband ripple (dB, 0=Butterworth)    [#.##]  :"; RIP;
145 INPUT " ", T$: IF T$ = "0" THEN RIP = 0 ELSE T = VAL(T$): IF T <> 0 THEN RIP = T
150 PRINT USING "                 Centre frequency (GHz)   [##.###]  :"; FZGC;
155 INPUT " ", T: OLDFZGC = FZGC: IF T <> 0 THEN FZGC = T
159 IF (FIRST OR OLDFZGC <> FZGC) THEN BWMC = 50 * FZGC' Default bw = 5%
160 PRINT USING "                          Bandwidth (MHz)  [###.#]  :"; BWMC;
165 INPUT " ", T: IF T <> 0 THEN BWMC = T
170 INPUT "                     Input/output impedance  [50]  : ", R
175 IF R = 0 THEN R = 50
180 PRINT
182 PRINT "Number of plotting points required at each side of centre, and freq step -"
184 PRINT USING "     Points  [##]  :"; NFR / 2;
186 INPUT " ", T: IF T <> 0 THEN NFR = 2 * INT(T)
190 IF NFR > 50 THEN NFR = 50
192 STP = .5 * BWMC
194 PRINT USING "Step (MHz)  [###]  :"; STP;
196 INPUT " ", T: IF T <> 0 THEN STP = T
198 '
200 COUNT = 0
210 FOR IP = -NFR / 2 TO NFR / 2
220     COUNT = COUNT + 1
230     FR(COUNT) = FZGC + (STP * .001 * IP)
240 NEXT IP
250 F1 = FZGC - .0005 * BWMC
260 F2 = FZGC + .0005 * BWMC
270 IF RIP > 0 THEN GOTO 330
280 BW3GC = F2 - F1
290 BWRGC = 0
300 BW3 = 1
310 GOSUB 2000  ' Butterworth response
320 GOTO 390
330 B = 1 / SQR(10 ^ (.1 * RIP) - 1)
340 CA = LOG(B + SQR(B * B - 1)) / (N)
350 BW3 = (EXP(CA) + EXP(-CA)) / 2
360 GOSUB 1700  ' Chebyshev response
370 BWRGC = F2 - F1
380 BW3GC = BWRGC * BW3
390 '
400 W = 2 * (F2 - F1) / (F2 + F1)
410 QF = FZGC / BW3GC
420 NFM = N - 1
430 QWVL = 11.8028 / (4 * FZGC)
440 FOR K = 1 TO NFM
450     AK(K) = 1 / (BW3 * SQR(G(K) * G(K + 1)))
460     RK(K) = AK(K) / QF
470 NEXT K
480 AKO = G(1) * BW3
490 AK(N) = AKO
500 AK(N + 1) = 0
510 QS = G(1) * BW3 * QF
520 CANH = (EXP(2 * PI * E / H) - 1) / (EXP(2 * PI * E / H) + 1)
530 ZM = 59.9585 * LOG(4 * H / (PI * D))
540 ZE = 59.9585 * LOG(CANH * H * 4 / (PI * D))
550 RKM = RK(1) * SQR(ZM / ZE)
560 Z = PI * D / (2 * H)
570 COTH = (EXP(Z) + 1) / (EXP(Z) - 1)
580 Y = PI * RKM / 4
590 T = COTH ^ Y
600 C(1) = (H / PI) * LOG((T + 1) / (T - 1))
610 MFL = N - 2
620 ' IF N-3<0 THEN AG=1 ELSE                                                                 IF N-3=0 THEN AG=2 ELSE AG=3
630 ON (2 + SGN(N) * 1) GOTO 690, 690, 640
640 FOR K = 2 TO MFL
650     Y = PI * RK(K) / 4
660     T = COTH ^ Y
670     C(K) = (H / PI) * LOG((T + 1) / (T - 1))
680 NEXT K
690 C(N - 1) = C(1)
700 X = SQR(PI * R / (4 * ZE * QS))
710 AQ = 2 * QWVL * ATN(X / SQR(1 - X * X)) / PI
720 QU = 2200 * H * SQR(FZGC)
730 SUMG = 0
740 FOR J1 = 1 TO N
750     SUMG = SUMG + G(J1)
760 NEXT J1
770 BLOSS = 4.34 * FZGC * SUMG / (QU * (F2 - F1))
780 DELA = SUMG / (2 * PI * (F2 - F1))
790 CLS : COLOR 3, 0: PRINT "DESIGN DATA FOR "; N; " POLE INTERDIGITAL FILTER": COLOR 7, 0
800 IF RIP > 0 THEN PRINT "Passband ripple "; RIP; " dB" ELSE PRINT "Butterworth response"
830 PRINT USING "Centre freq.         ##.#### GHz"; FZGC
840 PRINT USING "Cutoff freqs         ##.#### and ##.#### GHz"; F1; F2
850 PRINT USING "Ripple bandwidth      #.##### GHz"; BWRGC
860 PRINT USING "   3dB bandwidth      #.##### GHz"; BW3GC
870 PRINT USING "Fractional bandwidth  #.####"; W
875 PRINT
880 PRINT USING "Filter  Q       ####"; QF
885 PRINT USING "Estimated Qu    ####"; QU
890 PRINT USING "Loss based on this Qu   ##.# dB"; BLOSS
895 PRINT USING "Delay at band centre   ###.# ns"; DELA
900 LOCATE 25, 35: COLOR 3, 0: PRINT "Press " + ENTER$; : T$ = INPUT$(1): CLS
920 PRINT "FREQUENCY REJECTION INFORMATION"; TAB(67); "GHz"; TAB(74); "dB": COLOR 7, 0: PRINT
930 FOR JK = 1 TO NFR + 1
940    NFN = ABS(2 * (FR(JK) - FZGC) / (W * FZGC))
950    IF RIP > 0 THEN GOTO 980
960    ALOSS(JK) = 10 * LOG(1 + NFN ^ (2 * N)) / LOG(10)
970    GOTO 1020
980    IF NFN < 1 THEN NFN = 1
990    ANG = N * LOG(NFN + SQR(NFN * NFN - 1))
1000   YAK = .5 * (EXP(ANG) + EXP(-ANG))
1010   ALOSS(JK) = 10 * LOG(1 + (10 ^ (.1 * RIP) - 1) * YAK * YAK) / LOG(10)
1020   ALOSS = ALOSS(JK)
1030   FR = INT(FR(JK) * 10000) / 10000
1040   COLOR 14, 0: IF ALOSS < 64 THEN PRINT TAB(INT(ALOSS) + 1); "*";  ELSE PRINT TAB(64); ">";
1045   COLOR 7, 0: IF ALOSS > 99.99 THEN ALOSS = 99.99
1050   PRINT TAB(66); : PRINT USING "#.###  ##.##"; FR; ALOSS
1055 NEXT JK
1060 WO = 2 * PI * FZGC * 1E+09
1070 F = D / H
1080 CF = (-.0000422 + .0857397 * F + .0067853 * F * F - 9.092165E-02 * F ^ 3 + .169088 * F ^ 4) * PI * H * 2.54
1090 '
1100 WW = WO * 1E-12
1110 B2 = PI * AQ / (2 * QWVL)
1120 GG = 1 / R
1130 BB = -COS(B2) / (ZE * SIN(B2))
1140 EL1 = .8 * QWVL
1150 ANG = EL1 * PI / (2 * QWVL)
1160 B1 = ANG - B2
1170 YL = -COS(ANG) / (ZM * SIN(ANG))
1180 CP = WW * (CF + .17655 * D * D / (QWVL - EL1))
1190 Y1 = CP + YL
1200 EL2 = .87 * QWVL
1210 ANG = EL2 * PI / (2 * QWVL)
1220 B4 = ANG - B2
1230 YL = -COS(ANG) / (ZM * SIN(ANG))
1240 CD = WW * (CF + .17655 * D * D / (QWVL - EL2))
1250 Y2 = CD + YL
1260 EL3 = .95 * QWVL
1270 ANG = EL3 * PI / (2 * QWVL)
1280 B5 = ANG - B2
1290 YL = -COS(ANG) / (ZM * SIN(ANG))
1300 CQ = WW * (CF + .17655 * D * D / (QWVL - EL3))
1310 Y3 = CQ + YL
1320 ELEM = Y3 * Y2 * EL1 / ((Y1 - Y2) * (Y1 - Y3)) + Y1 * Y3 * EL2 / ((Y2 - Y1) * (Y2 - Y3)) + Y1 * Y2 * EL3 / ((Y3 - Y1) * (Y3 - Y2))
1330 TANN = SIN(B1) / COS(B1)
1340 YL = FNRJ(GG, BB + TANN / ZE, 1 - ZE * BB * TANN, ZE * GG * TANN)
1350 Y1 = CP + YL
1360 TANN = SIN(B4) / COS(B4)
1370 YL = FNRJ(GG, BB + TANN / ZE, 1 - ZE * BB * TANN, ZE * GG * TANN)
1380 Y2 = CD + YL
1390 TANN = SIN(B5) / COS(B5)
1400 YL = FNRJ(GG, BB + TANN / ZE, 1 - ZE * BB * TANN, ZE * GG * TANN)
1410 Y3 = CQ + YL
1420 ELEQ = Y3 * Y2 * EL1 / ((Y1 - Y2) * (Y1 - Y3)) + Y1 * Y3 * EL2 / ((Y2 - Y1) * (Y2 - Y3)) + Y1 * Y2 * EL3 / ((Y3 - Y1) * (Y3 - Y2))
1430 COLOR 3, 0: LOCATE 25, 25: PRINT "Press R to revise, " + ENTER$ + " to continue";
1435 T$ = INPUT$(1): CLS : COLOR 7, 0: IF T$ = "r" OR T$ = "R" THEN FIRST = 0: GOTO 70
1440 PRINT USING "Width (= quarter_-wavelength)   ###.##&"; QWVL * CV; UNIT$
1450 PRINT USING "Height                          ##.##&"; H * CV; UNIT$
1460 PRINT USING "Rod diameter                    ##.##&"; D * CV; UNIT$
1470 PRINT USING "External ### lines connect at ##.##& from ground end"; R; AQ * CV; UNIT$
1475 PRINT "End covers are required unless overhang is larger than default value"
1480 IF N > 5 THEN COLOR 3, 0: LOCATE 25, 30: PRINT "Press " + ENTER$ + " for sketch"; : T$ = INPUT$(1): CLS : COLOR 7, 0
1490 IF N > 5 THEN STARTLIN = 4 ELSE STARTLIN = 8
1500 LOCATE STARTLIN, 1: COLOR 3, 0
1510 PRINT " Ele #      Length                               Centre-to-centre    Cumulative";
1515 COLOR 7, 0
1520 F1$ = " (edge)                                                               ###.##" + UNIT$
1530 F2$ = "                                                    ###.##" + UNIT$
1540 F3$ = "   #        ###.##" + UNIT$ + "                                                  ###.##" + UNIT$
1550 CUMU = 0: LOCATE CSRLIN + 2, 1: PRINT USING F1$; CUMU * CV;
1560 LOCATE CSRLIN + 1, 1: PRINT USING F2$; E * CV;
1570 ELE = 1: CUMU = E
1575 LOCATE CSRLIN + 1, 1: PRINT USING F3$; ELE; ELEQ * CV; CUMU * CV;
1580 FOR ELE = 2 TO N - 1
1585     LOCATE CSRLIN + 1, 1: PRINT USING F2$; C(ELE - 1) * CV;
1590     CUMU = CUMU + C(ELE - 1)
1595     LOCATE CSRLIN + 1, 1: PRINT USING F3$; ELE; ELEM * CV; CUMU * CV;
1600 NEXT
1605 LOCATE CSRLIN + 1, 1: PRINT USING F2$; C(N - 1) * CV;
1610 CUMU = CUMU + C(N - 1)
1615 LOCATE CSRLIN + 1, 1: PRINT USING F3$; N; ELEQ * CV; CUMU * CV;
1620 CUMU = CUMU + E
1625 LOCATE CSRLIN + 1, 1: PRINT USING F2$; E * CV;
1630 LOCATE CSRLIN + 1, 1: PRINT USING F1$; CUMU * CV;
1670 LOCATE STARTLIN + 2, 1: COL = 30: GOSUB 3000             ' Draw the filter
1675 COLOR 3, 0: LOCATE 25, 13: PRINT "Press Shift-PrtSc to print, Q to quit, R or " + ENTER$ + " to revise";
1680 T$ = INPUT$(1): COLOR 7, 0: CLS : IF T$ = "q" OR T$ = "Q" THEN END ELSE FIRST = 0: GOTO 70
1689 '
1690 ' Subroutine for Chebyshev response
1700 C = 2 * RIP / 17.37
1710 BETA = LOG((EXP(C) + 1) / (EXP(C) - 1))
1720 GAMMA = .5 * (EXP(BETA / (2 * N)) - EXP(-BETA / (2 * N)))
1730 FOR K = 1 TO N
1740    A(K) = SIN(.5 * (2 * K - 1) * PI / N)
1750    B(K) = GAMMA ^ 2 + SIN(K * PI / N) ^ 2
1760 NEXT K
1770 G(1) = 2 * A(1) / GAMMA
1780 FOR K = 2 TO N
1790    G(K) = 4 * A(K - 1) * A(K) / (B(K - 1) * G(K - 1))
1800 NEXT K
1810 NN = N / 2
1820 NNN = (N + 1) / 2
1830 ' IF NNN-NN<0 THEN AG1=1 ELSE                                                                  IF NNN-NN=0 THEN AG1=2 ELSE AG1=3
1900 ON (2 + SGN(NNN - NN) * 1) GOTO 1910, 1910, 1930
1910 G(N + 1) = ((EXP(BETA / 2) + 1) / (EXP(BETA / 2) - 1)) ^ 2
1920 RETURN
1930 G(N + 1) = 1
1940 RETURN
1950 '
1990 ' Subroutine for Butterworth response
2000 POV2 = PI / 2
2010 FOR K = 1 TO N
2020    G(K) = 2 * SIN(POV2 * (2 * K - 1) / N)
2030 NEXT K
2040 G(N + 1) = 1
2050 RETURN
2950 '
2990 ' Subroutine to draw an N-pole filter starting at CSRLIN,COL
3000 TOPEND$ = CHR$(218) + CHR$(196) + " " + CHR$(179) + " " + STRING$(10, CHR$(196)) + CHR$(191)
3010 TOPGAP$ = CHR$(179) + "  " + CHR$(179) + SPACE$(11) + CHR$(179)
3020 MIDGAP$ = CHR$(179) + SPACE$(14) + CHR$(179)
3030 LROD$ = CHR$(222) + STRING$(13, CHR$(219)) + " " + CHR$(179)
3040 RROD$ = CHR$(179) + " " + STRING$(13, CHR$(219)) + CHR$(221)
3050 EVNBGAP$ = TOPGAP$
3060 ODDBGAP$ = CHR$(179) + SPACE$(11) + CHR$(179) + "  " + CHR$(179)
3070 EVNBEND$ = CHR$(192) + CHR$(196) + " " + CHR$(179) + " " + STRING$(10, CHR$(196)) + CHR$(217)
3080 ODDBEND$ = CHR$(192) + STRING$(10, CHR$(196)) + " " + CHR$(179) + " " + CHR$(196) + CHR$(217)
3090 COLOR 14, 0
3100 LOCATE CSRLIN, COL: PRINT TOPEND$;
3110 LOCATE CSRLIN + 1, COL: PRINT TOPGAP$;
3120 LOCATE CSRLIN + 1, COL: PRINT LROD$;
3130 FOR I = 1 TO (INT(N + 1) / 2 - 1)         ' Fill middle
3140     LOCATE CSRLIN + 1, COL: PRINT MIDGAP$;
3150     LOCATE CSRLIN + 1, COL: PRINT RROD$;
3160     LOCATE CSRLIN + 1, COL: PRINT MIDGAP$;
3170     LOCATE CSRLIN + 1, COL: PRINT LROD$;
3180 NEXT
3190 IF (N + 1) / 2 = INT((N + 1) / 2) THEN GOTO 3250
3200 LOCATE CSRLIN + 1, COL: PRINT MIDGAP$;     ' Finish odd-number
3210 LOCATE CSRLIN + 1, COL: PRINT RROD$;
3220 LOCATE CSRLIN + 1, COL: PRINT ODDBGAP$;
3230 LOCATE CSRLIN + 1, COL: PRINT ODDBEND$;
3240 GOTO 3270
3250 LOCATE CSRLIN + 1, COL: PRINT EVNBGAP$;    ' Finish even-number
3260 LOCATE CSRLIN + 1, COL: PRINT EVNBEND$;
3270 COLOR 7, 0
3280 RETURN

